/*
 * tmos - user.c
 * 	version 0.0.0
 * 
 * Copyright (C) 2009  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <tmos/kernel.h>
#include <asm/system.h>

void __i51_user_memset(char __user *buf, char c, user_size_t len)
{
#if CONFIG_OPTIMIZE_SPEED
	while (len >= 4) {
		buf[--len] = c;
		buf[--len] = c;
		buf[--len] = c;
		buf[--len] = c;
	}
	if (len >= 2) {
		buf[--len] = c;
		buf[--len] = c;
	}
	if (len)
		buf[--len] = c;
#else
	while (len)
		buf[--len] = c;
#endif
}

#if 0 && CONFIG_KERNEL_PREEMPT
void i51_user_memset(char __user *buf, char c, user_size_t len) __reentrant
{
	preempt_disable();
	__i51_user_memset(buf, c, len);
	preempt_enable();
}
#endif
