/*
 * tmos - kmem.c
 * Copyright (C) 2010  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Fundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <tmos/kernel.h>
#include <tmos/port.h>
#include <tmos/errno.h>

#if KERNEL_TASK_SIZE > OFF_MAX
#define KMEM_SIZE	OFF_MAX
#else 
#define KMEM_SIZE	KERNEL_TASK_SIZE
#endif

msg_ssize_t dev_kmem_xmit(port_t port, char __user *buf,
		msg_size_t len, msg_size_t max_resp_len, msg_flags_t flags,
		off_t off)
	reentrant
{
	if (len)
		return -EINVAL;

	if (max_resp_len > KMEM_SIZE - off)
		max_resp_len = KMEM_SIZE - off;
	if (copy_to_user(buf, (void __kernel *)off, max_resp_len))
		return -EFAULT;
	return max_resp_len;
}
