/*
 * tmos - serial.h
 *
 * Copyright (C) 2005..2009  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __ASM_SERIAL_H
#define __ASM_SERIAL_H

#include <tmos/config.h>
#include <asm/system.h>
#include <asm/irqs.h>

#ifdef CONFIG_SERIAL_TIMER3
#define B9600		0
#define B19200		1
#define B38400		2
#define B57600		3
#define B115200		4
#define B125000		5
#define B150000		6
#define B230400		7
#else

#ifdef CONFIG_SERIAL_TIMER2
#define CALC_SPEED(speed) \
	(65536UL - (CONFIG_OSCILLATOR + 16UL * (speed)) / (32UL * (speed)))
#else
#define CALC_SPEED(speed) \
	(256 - (CONFIG_OSCILLATOR + 96UL * (speed)) / (192UL * (speed)))
#endif

#define B9600		CALC_SPEED(9600)
#define B19200		CALC_SPEED(19200)
#define B38400		CALC_SPEED(38400)
#define B57600		CALC_SPEED(57600)
#define B115200		CALC_SPEED(115200)
#define B230400		CALC_SPEED(230400)
#endif

void tx_send_raw(unsigned char x) __reentrant;
void __tx_send_raw(unsigned char x) __using I51_SERIAL_BANK __reentrant;

#endif
