/*
 * tmos - watchdog.h
 *
 * Copyright (C) 2009  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __WATCHDOG_H
#define __WATCHDOG_H

#if CONFIG_AT89S8252_WDT
#include <tmos/at89s8252_wdt.h>
#elif CONFIG_WATCHDOG
void watchdog_init(void);
void watchdog_refresh(void);
#else
#define watchdog_init()		do { } while(0)
#define watchdog_refresh()	do { } while(0)
#endif

#endif
